/*
 * Copyright 2003-2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package groovy.bugs

class Groovy4516Bug extends GroovyTestCase {
    void testDelegateMethodsWithDefaultValues() {
        assertScript """
            class Del4516 {
                def doSomething(boolean flag = true) { 
                    flag 
                }
            }
            
            class AClass4516 { 
                @Delegate Del4516 Del4516 = new Del4516() 
            }
            
            def a = new AClass4516()
            assert a.doSomething(false) == false
            assert a.doSomething() == true
        """
    }
}
