/*
 * Copyright 2003-2013 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.codehaus.groovy.classgen.asm

class CovariantReturnBytecodeTest extends AbstractBytecodeTestCase {
    void testCovariance(){
        def code = compile (method:'super$3$attach', classNamePattern:'C', '''
            abstract class A {
                A attach(){return this}
            }
            class B extends A {
                @Override
                B attach(){return (B) super.attach()}
            }
            class C extends B {
                @Override
                C attach(){return (C) super.attach()}
            }
        ''')
        assert code.hasSequence([
            "INVOKESPECIAL B.attach ()LB;"
        ])
    }
}
